
package com.paisasoft.rnbridges.unstoppablebackgroundservice;

import android.content.Intent;

import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.Callback;

import java.util.Date;

import javax.annotation.Nonnull;

public class RNUnstoppableBackgroundServiceModule extends ReactContextBaseJavaModule {

  public static final String REACT_CLASS = "UnstoppableService";
  private static ReactApplicationContext reactContext;

  public RNUnstoppableBackgroundServiceModule(ReactApplicationContext reactContext) {
    super(reactContext);
    this.reactContext = reactContext;
  }

  @Nonnull
  @Override
  public String getName() {
      return REACT_CLASS;
  }

  @ReactMethod
  public void startService() {
      this.reactContext.startService(new Intent(this.reactContext, UnstoppableService.class));
  }

  @ReactMethod
  public void getStatus(Callback successCallback) {
      boolean isRunning = (UnstoppableService.getInstance() != null);

      successCallback.invoke(null, isRunning);
  }

  @ReactMethod
  public void getStartDate(Callback successCallback) {
      Date startDate = (UnstoppableService.getStartDate());
      if (startDate != null){
          String returnValue = android.text.format.DateFormat.format("yyyy-MM-dd hh:mm:ss a", startDate).toString();
          successCallback.invoke(null, returnValue);
      }else{
          successCallback.invoke(null, null);
      }
  }  
}