package com.paisasoft.rnbridges.unstoppablebackgroundservice;

import android.app.Notification;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.os.IBinder;
import android.support.v4.app.NotificationCompat;

import com.facebook.react.HeadlessJsTaskService;

import java.util.Date;

public class UnstoppableService extends Service {

  private static UnstoppableService instance = null;
  private static Date startDate = null;

  private static final int SERVICE_NOTIFICATION_ID = 12345;
  private static final String CHANNEL_ID = "12345";

  private Handler handler = new Handler();
  private Runnable runnableCode = new Runnable() {
      @Override
      public void run() {
          Context context = getApplicationContext();
          Intent myIntent = new Intent(context, UnstoppableEventService.class);
          context.startService(myIntent);
          HeadlessJsTaskService.acquireWakeLockNow(context);
          handler.postDelayed(this, 2000);
      }
  };

  public static UnstoppableService getInstance(){
      return instance;
  }

  public static Date getStartDate(){
      return startDate;
  }


  @Override
  public IBinder onBind(Intent intent) {
      return null;
  }

  @Override
  public void onCreate() {
      super.onCreate();

      this.instance = this;

      this.startDate = new Date();
  }

  @Override
  public void onDestroy() {
      super.onDestroy();

      this.instance = null;

      this.startDate = null;
  }

  @Override
  public int onStartCommand(Intent intent, int flags, int startId) {
      this.instance = this;

      this.startDate = new Date();

      this.handler.post(this.runnableCode);
      Intent notificationIntent = new Intent(this, MainActivity.class);
      PendingIntent contentIntent = PendingIntent.getActivity(this, 0, notificationIntent, PendingIntent.FLAG_CANCEL_CURRENT);
      Notification notification = new NotificationCompat.Builder(this, CHANNEL_ID)
              .setContentTitle("UnstoppableService service")
              .setContentText("Running...")
              // .setSmallIcon(R.mipmap.ic_launcher)
              .setContentIntent(contentIntent)
              .setOngoing(true)
              .build();
      startForeground(SERVICE_NOTIFICATION_ID, notification);
      return START_STICKY;
  }

}
